<template>
    <div class="common-phrases">
        <el-popover placement="right" width="400" trigger="click">
            <div>
                <el-tag
                    :key="index"
                    v-for="(tag, index) in tags"
                    closable
                    effect="dark"
                    :disable-transitions="false"
                    @close="handleClose(tag, index)"
                    @click="handleSelect(tag)"
                >
                    {{ tag.msg }}
                </el-tag>
                <el-input
                    class="input-new-tag"
                    v-if="inputVisible"
                    v-model="inputValue"
                    ref="saveTagInput"
                    size="small"
                    @keyup.enter.native="handleInputConfirm"
                    @blur="handleInputConfirm"
                />
                <el-tag v-else class="button-new-tag" @click="showInput">
                    + 新增常用语
                </el-tag>
            </div>
            <el-button slot="reference" type="primary">常用语</el-button>
        </el-popover>
    </div>
</template>
<script>
export default {
    name: 'CommonPhrases',
    data() {
        return {
            inputVisible: false,
            inputValue: '',
            tags: [
                {
                    msg: '常用语1',
                },
                {
                    msg: '常用语2',
                },
                {
                    msg: '常用语3',
                },
                {
                    msg: '常用语4',
                },
                {
                    msg: '常用语5',
                },
                {
                    msg: '常用语6常用语常用语常用语常用语常用语常用语',
                },
            ],
        }
    },
    methods: {
        handleClose(tag, index) {
            this.tags.splice(index, 1)
        },
        handleInputConfirm() {
            if (this.inputValue) {
                let inputValue = this.inputValue
                let tag = {
                    msg: inputValue,
                }
                this.tags.splice(this.tags.length - 1, 0, tag)
                console.log(this.tags)
            }
            this.inputVisible = false
            this.inputValue = ''
        },
        showInput() {
            this.inputVisible = true
            this.$nextTick((_) => {
                this.$refs.saveTagInput.$refs.input.focus()
            })
        },
        handleSelect(tag) {
            this.$emit('comfirm', tag.msg)
        },
    },
}
</script>
<style lang="scss" scoped>
.common-phrases{
    width: 100%;
}
/deep/.el-tag {
    margin:5px;
    cursor: pointer;
}
.button-new-tag {
    margin:5px;
    cursor: pointer;
}
.input-new-tag {
    width: 200px;
    margin:5px;
    vertical-align: bottom;
}
</style>